#include "buffer.h"

void BUF_flush(BUF_t *buffer)
{
  buffer->get=0;
  buffer->put=0;
  buffer->n=0;
}

void BUF_init(BUF_t *buffer,char *buf,uint16_t size)
{
  buffer->buf = buf;
  buffer->size = size;
}

uint8_t BUF_newpos(uint8_t i,uint16_t size)
{
  return (i+1) == size ? 0 : i+1;
}

uint8_t BUF_get(BUF_t *buffer)
{
	if(buffer->n>0)
	  {
		uint8_t pos;
		pos=buffer->get;
		buffer->get=BUF_newpos(buffer->get,buffer->size);
		buffer->n--;
        return buffer->buf[pos];
	  }
	else
      return 0;
}

void BUF_put(uint8_t val, BUF_t *buffer)
{
    buffer->buf[buffer->put]=val;
    buffer->put=BUF_newpos(buffer->put,buffer->size);
    buffer->n++;
}
